list p=16F887
#include <P16f887.INC>


CBLOCK 0x20
var
temp
num
ENDC


#define boton_a 	PORTB,0
#define boton_b 	PORTB,1
#define boton_c 	PORTB,2
#define boton_d 	PORTB,3
#define boton_e 	PORTB,4
#define boton_f 	PORTB,5
#define sumar		PORTB,6
#define restar		PORTB,7
#define LEDS		PORTC
#define Display_1 	PORTA
#define Display_2 	PORTD

org 0;inicio del programa
;******************************************************
;********programa principal de seteos de segundos**
;******************************************************
principal	
		call  PIC_SET ;seteo del pic 16f887
		clrf  LEDS
		clrf  Display_1
		clrf  Display_2
		clrf var		
		clrf temp	

menu_inicio

		btfss boton_a
		goto  seguir_b
		goto  test_a
seguir_b
		btfss boton_b
		goto  seguir_c
		goto  test_b
seguir_c
		btfss boton_c
		goto  seguir_d
		goto  test_c
seguir_d
		btfss boton_d
		goto  seguir_e
		goto  test_d
seguir_e
		btfss boton_e
		goto  seguir_f
		goto  test_e
seguir_f
		btfss boton_f
		goto  seguirs
		goto  test_f
seguirs
		btfss sumar
		goto  seguirr
		goto  contar
seguirr
		btfss restar
		goto  menu_inicio
		goto  decontar
	
test_a
	btfsc boton_a
	goto test_a
	btfsc LEDS,0
	goto off_a
	movlw d'1'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_a
	movlw d'1'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio

test_b
	btfsc boton_b
	goto test_b
	btfsc LEDS,1
	goto off_b
	movlw d'2'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_b
	movlw d'2'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio

test_c
	btfsc boton_c
	goto test_c
	btfsc LEDS,2
	goto off_c
	movlw d'4'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_c
	movlw d'4'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio

test_d
	btfsc boton_d
	goto test_d
	btfsc LEDS,3
	goto off_d
	movlw d'8'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_d
	movlw d'8'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio
test_e
	btfsc boton_e
	goto test_e
	btfsc LEDS,4
	goto off_e
	movlw d'16'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_e
	movlw d'16'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio
test_f
	btfsc boton_f
	goto test_f
	btfsc LEDS,5
	goto off_f
	movlw d'32'
	addwf var
	movfw var
	movwf LEDS
	goto menu_inicio
off_f
	movlw d'32'
	subwf var
	movfw var
	movwf LEDS
	goto menu_inicio

contar
	btfsc sumar
	goto contar
	movfw var
	movwf temp
	andlw d'7'
	movwf num
	rlf temp,1
	swapf temp,0
	andlw d'7'
	addwf num		
  	movfw num
	movwf var

	movfw var
	call BIN_a_BCD
	movwf temp
	andlw d'15'
	call Numero_a_7Segmentos
	movwf Display_2
	swapf temp,0
	andlw d'15'
	call Numero_a_7Segmentos
	movwf Display_1		
	goto menu_inicio

decontar
	btfsc restar
	goto decontar
	movfw var
	movwf temp
	andlw d'7'
	movwf num
	rlf temp,1
	swapf temp,0
	andlw d'7'
	subwf num		
  	movfw num
	movwf var

	movfw var
	call BIN_a_BCD
	movwf temp
	andlw d'15'
	call Numero_a_7Segmentos
	movwf Display_2
	swapf temp,0
	andlw d'15'
	call Numero_a_7Segmentos
	movwf Display_1		
	goto menu_inicio

;;;;;;;;;;;;;;;;;;;;;;;;
		;funciones
;;;;;;;;;;;;;;;;;;;;;;;;;

PIC_SET
		banksel ANSELH
		clrf ANSELH
		clrf ANSEL
	
		banksel TRISB
		bsf boton_a
		bsf boton_b
		bsf boton_c
		bsf boton_d
		bsf boton_e
		bsf boton_f
		bsf sumar
		bsf restar
		clrf  LEDS ;salidas de leds al puerto C
		clrf  Display_1
		clrf  Display_2
		
		banksel PORTA
		
return

CBLOCK						; En las subrutinas no se debe fijar la direccin
	BCD_Centenas				; de la RAM de usuario. Se toma a continuacin de
	BCD_Decenas					; la ltima asignada.
	BCD_Unidades	
	ENDC
;
BIN_a_BCD
	clrf	BCD_Centenas		; Carga los registros con el resultado inicial.
	clrf	BCD_Decenas			; En principio las centenas y decenas a cero.
	movwf	BCD_Unidades		; Se carga el nmero binario a convertir.
BCD_Resta10
	movlw	.10					; A las unidades se les va restando 10 en cada
	subwf	BCD_Unidades,W		; pasada. (W)=(BCD_Unidades) -10.
	btfss	STATUS,C			; C = 1?, (W) positivo?, (BCD_Unidades)>=10?
	goto 	BIN_BCD_Fin			; No, es menor de 10. Se acab.
BCD_IncrementaDecenas
	movwf	BCD_Unidades		; Recupera lo que queda por restar.
	incf	BCD_Decenas,F		; Incrementa las decenas y comprueba si ha llegado
	movlw	.10					; a 10. Lo hace mediante una resta.
	subwf	BCD_Decenas,W		; (W)=(BCD_Decenas)-10).
	btfss	STATUS,C			; C = 1?, (W) positivo?, (BCD_Decenas)>=10?
	goto	BCD_Resta10			; No. Vuelve a dar otra pasada, restndole 10 a
BCD_IncrementaCentenas			; las unidades.
	clrf	BCD_Decenas			; Pone a cero las decenas 
	incf	BCD_Centenas,F		; e incrementa las centenas.
	goto	BCD_Resta10			; Otra pasada: Resta 10 al nmero a convertir.
BIN_BCD_Fin
	swapf	BCD_Decenas,W		; En el nibble alto de (W) tambin las decenas.
	addwf	BCD_Unidades,W		; En el nibble bajo de (W) las unidades.
	return						; Vuelve al programa principal.
	
CBLOCK
	Display7s_Dato				; Aqu se reservar el valor del dato de entrada.
	ENDC
	
Numero_a_7Segmentos
	andlw	b'00001111'			; Se queda con el nibble bajo.
	addlw	'0'					; Se pasa a ASCII sumndole el valor ASCII
								; del "0" y ejecuta "ASCII_7_Segmentos".
ASCII_a_7Segmentos
	movwf	Display7s_Dato		; Guarda el valor del carcter.
	sublw	' ' 				; Comprueba si es " " (espacio).
	btfsc	STATUS,Z			; Es distinta de " " (espacio)?, Z=0?
	retlw	00h					; Es " ". Devuelve el cdigo 7-Segmentos del " ".
	movf	Display7s_Dato,W	; Recupera el valor del dato de entrada.
	sublw	'' 				; Comprueba si es "".
	btfsc	STATUS,Z			; Es distinta de ""?, Z=0?
	retlw	55h					; Es "". Devuelve el cdigo 7-Segmentos de "".
	movf	Display7s_Dato,W	; Recupera el valor del dato de entrada.
	sublw	'' 				; Comprueba si es "".
	btfsc	STATUS,Z			; Es distinta de ""?, Z=0?
	retlw	63h					; Es "". Devuelve el cdigo 7-Segmentos de "".
;
	movf	Display7s_Dato,W	; Comprueba si el cdigo ASCII es mayor que la "Z".
	sublw	'Z'					; (W)='Z'-(Display7s_Dato)
	btfss	STATUS,C			; C=1?, (W) positivo?, 'Z'>=(Display7s_Dato)?
	retlw	b'10000000'			; Si el cdigo ASCII es mayor que 'Z' es un error.
	movlw	'+' 				; Averigua en qu orden est el carcter ledo
	subwf	Display7s_Dato,W	; dentro de la tabla de conversin, respecto del
	btfss	STATUS,C			; primero que es '+'.
	retlw	b'10000000'			; Si el cdigo ASCII es menor que '+' es un error.
;
	addwf	PCL,F				; Obtiene el cdigo 7 segmentos.
InicioTablaASCII
	DT	46h, 04h, 40h, 80h, 00h, 3Fh, 06h, 5Bh, 4Fh, 66h, 6Dh			; Signos y
	DT	7Dh, 07h, 7Fh, 67h, 41h, 88h, 00h, 48h, 00h, 00h, 00h			; nmeros.
	DT	77h, 7Ch, 39h, 5Eh, 79h, 71h, 6Fh, 76h, 19h, 1Eh, 7Ah, 38h, 37h ; Letras.
	DT	54h, 3Fh, 73h, 67h, 50h, 6Dh, 78h, 1Ch, 3Eh, 1Dh, 70h, 6Eh, 49h
FinTablaASCII
;
; Esta es la tabla para la visualizacin en display de siete segmentos (Ver figura 11-3).

	;IF (FinTablaASCII > 0xFF)
	;	ERROR	"CUIDADO!: La tabla ha superado el tamao de la pgina de los"
	;	MESSG	"primeros 256 bytes de memoria ROM. NO funcionar correctamente."
	;ENDIF

;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================

end;finalizacion del programa
